#!perl -w

# bring in the perl module that includes copy
use File::Copy;

# the root dir where the unix files will live on my pc
#$local_unix_source_dir = "c:/projects/cloudy/trunk/unix/source";
$local_unix_data_dir = "c:/projects/cloudy/trunk/unix/data";
$local_unix_main_dir = "c:/projects/cloudy/trunk/unix";

# this is where the original source files live on my pc
#$original_source_dir = "c:/projects/cloudy/trunk/source";
$original_data_dir =   "c:/projects/cloudy/trunk/data";

# this is the last source.tar.gz, will compare this time stamp with debug exe
# and bail if tar file is younger than exe
#$local_unix_sourcetar = "$local_unix_main_dir"."/source.tar.gz";
# --------------------------------------------------------------------------

# the root dir where the unix files will live on the linux cluster
#$cluster_unix_source_dir = "u:/cloudy/trunk/source";
$cluster_unix_data_dir =   "u:/cloudy/trunk/data";

# this is the ftp site on gradj
$ftp_last = "u:/pub/gary/bleeding_edge/last/";

# the root dir where the unix files will live on my pc
#$local_unix_source_dir = "c:/projects/cloudy/trunk/unix/source";
$local_unix_data_dir = "c:/projects/cloudy/trunk/unix/data";
$local_unix_main_dir = "c:/projects/cloudy/trunk/unix";

# the win dir within the unix set
#$local_win_source_dir = "c:/projects/cloudy/trunk/win/source"; 
$local_win_data_dir = "c:/projects/cloudy/trunk/win/data";

#this is where backup files will be dropped
$unixhome = "c:/projects/cloudy/trunk/unix";

# this block - clean out the target directories so we get fresh copies

# move to pc unix data dir
chdir( "$local_unix_data_dir" ) or die " invalid unix data directory for data\n";
print(" moved to unix target data directory, about to delete all files\n");
# remove the unix data files
unlink <*> ; 

# move to win data dir
chdir( "$local_win_data_dir" ) or die " invalid win data directory for data\n";
print(" moved to win target data directory, about to delete all files\n");
# remove the win data files
unlink <*> ;

# move to original data directory
chdir( $original_data_dir ) or die " invalid directory for data\n";

# now do all data files in data dir
# there is a different set of data files tar'd into data.tar in tsuite/auto, this is done
# by the autorun.pl script
$input = "readme_data.htm";
$output = "$local_unix_data_dir"."/"."readme_data.htm";
system "dos2unix < $input  > $output" ;
$output = "$local_win_data_dir"."/"."$input";
# simply copy the html file here
copy( $input  , $output );

# treate this as a binary file
copy( "clouds.jpg" , "$local_unix_data_dir"."/"."clouds.jpg" );
copy( "clouds.jpg" , "$local_win_data_dir"."/"."clouds.jpg" );

# the tex and pdf file for P van Hoof's writeup on the new grains
# first do the pdf version as a binary file
copy( "vanhoof_grain_model.pdf" , "$local_unix_data_dir"."/"."vanhoof_grain_model.pdf" );
copy( "vanhoof_grain_model.pdf" , "$local_win_data_dir"."/"."vanhoof_grain_model.pdf" );
# next the tex master document
$input = "vanhoof_grain_model.tex";
$output = "$local_unix_data_dir"."/"."vanhoof_grain_model.tex";
# convert eol for unix version
system "dos2unix < $input  > $output" ;
$output = "$local_win_data_dir"."/"."$input";
# simply copy the file to the win dir
copy( $input  , $output );
# next the ps output
$input = "vanhoof_grain_model.ps";
$output = "$local_unix_data_dir"."/"."vanhoof_grain_model.ps";
# convert eol for unix version
system "dos2unix < $input  > $output" ;
$output = "$local_win_data_dir"."/"."$input";
# simply copy the file to the win dir
copy( $input  , $output );

# copy all data files
while( defined( $input = glob("*.dat") ) )
{
	print( "$input going to " );
	$output = "$local_unix_data_dir"."/"."$input";
	print("$output\n");
	# actually execute the code
	system "dos2unix < $input  > $output";
#
#       now do win version
	print( "$input going to " );
	$output = "$local_win_data_dir"."/"."$input";
	print("$output\n");
	# simply copy the source here
	copy( $input  , $output );
}

# copy all opacity files
while( defined( $input = glob("*.opc") ) )
{
	print( "$input going to " );
	$output = "$local_unix_data_dir"."/"."$input";
	print("$output\n");
	# actually execute the code
	system "dos2unix < $input  > $output";
#
#       now do win version
	print( "$input going to " );
	$output = "$local_win_data_dir"."/"."$input";
	print("$output\n");
	# simply copy the source here
	copy( $input  , $output );
}

# copy all input scripts
while( defined( $input = glob("*.in") ) )
{
	print( "$input going to " );
	$output = "$local_unix_data_dir"."/"."$input";
	print("$output\n");
	# actually execute the code
	system "dos2unix < $input  > $output";
#
#       now do win version
	print( "$input going to " );
	$output = "$local_win_data_dir"."/"."$input";
	print("$output\n");
	# simply copy the source here
	copy( $input  , $output );
}

# copy all ini scripts
while( defined( $input = glob("*.ini") ) )
{
	print( "$input going to " );
	$output = "$local_unix_data_dir"."/"."$input";
	print("$output\n");
	# actually execute the code
	system "dos2unix < $input  > $output";
#
#       now do win version
	print( "$input going to " );
	$output = "$local_win_data_dir"."/"."$input";
	print("$output\n");
	# simply copy the source here
	copy( $input  , $output );
}

# copy all rfi scripts
while( defined( $input = glob("*.rfi") ) )
{
	print( "$input going to " );
	$output = "$local_unix_data_dir"."/"."$input";
	print("$output\n");
	# actually execute the code
	system "dos2unix < $input  > $output";
#
#       now do win version
	print( "$input going to " );
	$output = "$local_win_data_dir"."/"."$input";
	print("$output\n");
	# simply copy the source here
	copy( $input  , $output );
}

# copy all szd scripts
while( defined( $input = glob("*.szd") ) )
{
	print( "$input going to " );
	$output = "$local_unix_data_dir"."/"."$input";
	print("$output\n");
	# actually execute the code
	system "dos2unix < $input  > $output";
#
#       now do win version
	print( "$input going to " );
	$output = "$local_win_data_dir"."/"."$input";
	print("$output\n");
	# simply copy the source here
	copy( $input  , $output );
}


print("\n=========================\n");
print("All data files have been copied to trunk/unix/data subdir\n");
print("=========================\n");

print( "data, source, tsuite files copied to win and pc unix \n");

# move to pc unix data directory
if( !chdir( $local_unix_data_dir ) )
{
       printf(" invalid directory for local unix data directory\n");
       exit(1);
}
# this loops over all files in the pc unix data directory
# and copies unix version to subdir unix on cluster, which is now empty
while( defined( $input = glob("*") ) )
{
	print( "$input going to " );
	$output = "$cluster_unix_data_dir"."/"."$input";
	print("$output\n");
	# actually copy the file
	copy( $input  , $output );
}

# now zip up the files we created
if( !chdir( "$unixhome" ) )
{
       printf(" invalid unix home directory for unix home\n");
       exit(1);
}
print(" moved to unix home directory\n");

# remove old gzipd file if it exists
if( -e "data.tar.gz" )
{
   unlink("data.tar.gz" );
}

# ----------------------------------------------------------
#   tar the files

# tar pc unix data
if( !chdir( "$local_unix_data_dir" ) )
{
       printf(" invalid directory for local data source\n");
       exit(1);
}
$tarfile = "../"."data.tar";
system "tar -cf $tarfile * ";
print( "about to gzip $tarfile\n" );
system "gzip $tarfile ";

# move to main dir so that we can copy tar.gz files to ftp site
if( !chdir( "$local_unix_main_dir" ) )
{
       printf(" invalid directory for main unix\n");
       exit(1);
}
# finally copy the newly created files to the ftp site
#copy( "source.tar.gz" , "u:/pub/gjf/source.tar.gz" );
#copy( "data.tar.gz" , "u:/pub/gjf/data.tar.gz" );
copy( "data.tar.gz" , $ftp_last );


# remove old gzipd file if it exists
if( -e "data.zip" )
{
   unlink("data.zip" );
}

# win data
system "c:\\u\\wzzip   data.zip $local_win_data_dir ";

# finally copy the newly created files to the ftp site
copy( "data.zip" , $ftp_last );

# all is finished, copy *.mod, the stellar continua, to local unix data so
# that gcc can get to it
system "cp $original_data_dir/*.mod $local_unix_data_dir ";

print("\n=========================\n");

